<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center" v-if="pre_diagnosis_result.length != 0">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color:white">
            Wait . . . {{ pre_diagnosis_result.length }}/{{
              data_display.upload_id.length
            }}
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>

    <div class="text-center" v-else>
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color:white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- Diagnosis Result -->
    <div class="ml-4">
      <span style="font-size:36px">
        <B>Pre<v-icon>mdi-minus-thick</v-icon>Diagnosis Result</B>
      </span>
    </div>
    <!-- Diagnosis Result -->
    <br />

    <!-- dialog_view_zoom -->
    <v-dialog v-model="dialog_view_zoom" persistent scrollable max-width="1000px">
      <v-card>
        <v-card-title style="color:white;background:#428bca">
          Zoom Result
          <v-spacer></v-spacer>
          <!-- <v-btn icon dark @click="dialog_feedback = true">
            <v-icon>mdi-message-processing-outline</v-icon>
          </v-btn> -->
          <v-btn icon dark @click="close_dialog_feedback()">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-card-title>
        <v-divider></v-divider>
        <v-card-text style="height: 600px;">
          <v-row v-if="view_zoom_item.link_s3_plot">
            <v-col cols="12" sm="6" md="6">
              <v-img
                :src="view_zoom_item.link_s3_png"
                style="cursor:zoom-in"
                @click="view_big_zoom()"
              ></v-img>
            </v-col>
            <v-col cols="12" sm="6" md="6" v-if="view_zoom_item.link_s3_plot">
              <v-img
                :src="view_zoom_item.link_s3_plot"
                style="cursor:zoom-in"
                @click="view_big_zoom()"
              ></v-img>
            </v-col>
          </v-row>
          <v-row v-else>
            <v-col cols="12" sm="3" md="3"></v-col>
            <v-col cols="12" sm="6" md="6">
              <v-img
                :src="view_zoom_item.link_s3_png"
                style="cursor:zoom-in"
                @click="view_big_zoom()"
              ></v-img>
            </v-col>
            <v-col cols="12" sm="3" md="3"></v-col>
          </v-row>
          <v-row>
            <v-col cols="12" class="text-start">
              <h3 style="color:black" class="mb-2">
                File Name : {{ view_zoom_item.old_filename }}
              </h3>
              <v-divider></v-divider>
            </v-col>
            <v-col cols="12" class="text-start">
              <h3 style="color:black" class="mb-2">
                Patient Name : {{ view_zoom_item.patient_name }}
              </h3>
              <v-divider></v-divider>
            </v-col>
            <v-col cols="12" class="text-start">
              <h3 style="color:black" class="mb-2">
                H/N : {{ view_zoom_item.HN }}
              </h3>
              <v-divider></v-divider>
            </v-col>
            <v-col cols="12" class="text-start">
              <h3 style="color:black" class="mb-2">
                Status :
                <span v-for="item in view_zoom_item.list_status_disease" :key="item">
                  <span>{{ item }}<span v-if="item != 'Normal'">%</span></span>
                  <br />
                  <span class="ml-12"></span>
                  <span class="ml-3"></span>
                </span>
              </h3>
              <v-divider></v-divider>
            </v-col>
            <v-col cols="12" class="text-start" v-if="view_zoom_item.feed_back == ''">
              <v-text-field
                dense
                label="Feedback"
                v-model="form_feedback.feed_back"
              ></v-text-field>
            </v-col>
            <v-btn class="ml-2" depressed color="primary" @click="feedback()" v-if="view_zoom_item.feed_back == ''">Submit</v-btn>
            <v-col cols="12" class="text-start" v-else>
              <h3 style="color:black" class="mb-2">
                Feedback :
                <span>
                  <span> {{ view_zoom_item.feed_back }}</span>
                  <br />
                  <span class="ml-12"></span>
                  <span class="ml-4"></span>
                </span>
              </h3>
              <v-divider></v-divider>
            </v-col>
          </v-row>
        </v-card-text>
      </v-card>
    </v-dialog>
    <!-- dialog_end_view_zoom -->

    <!-- dialog_view_big_zoom -->
    <v-dialog v-model="dialog_view_big_zoom" persistent scrollable max-width="1500px">
      <v-card>
        <v-card-title style="color:white;background:#428bca">
          Zoom Result
          <v-spacer></v-spacer>
          <v-btn icon dark @click="dialog_view_big_zoom = false">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-card-title>
        <v-divider></v-divider>
        <v-card-text style="height: 600px;">
          <v-row v-if="view_zoom_item.link_s3_plot">
            <v-col cols="12" sm="6" md="6">
              <v-img
                :src="view_zoom_item.link_s3_png"
                style="cursor:pointer"
              ></v-img>
            </v-col>
            <v-col cols="12" sm="6" md="6" v-if="view_zoom_item.link_s3_plot">
              <v-img
                :src="view_zoom_item.link_s3_plot"
                style="cursor:pointer"
              ></v-img>
            </v-col>
          </v-row>
          <v-row v-else>
            <v-col cols="12" sm="3" md="3"></v-col>
            <v-col cols="12" sm="6" md="6">
              <v-img
                :src="view_zoom_item.link_s3_png"
                style="curser:pointer"
              ></v-img>
            </v-col>
            <v-col cols="12" sm="3" md="3"></v-col>
          </v-row>
        </v-card-text>
      </v-card>
    </v-dialog>
    <!-- dialog_end_view_big_zoom -->

    <!-- display -->
    <v-container>
      <v-data-table v-if="show_result" :headers="headers" :items="pre_diagnosis_result" :footer-props="{'items-per-page-options': [10, 20, 50, 100]}" class="elevation-1">
        <template v-slot:item.status="{ item }">
          <span v-for="(items, i) in item.list_status_disease" :key="i">
            {{ items }}
            <span v-if="items != 'Normal' && items != 'normal'">%</span>
            <br />
          </span>
        </template>
        <template v-slot:item.old_filename="{ item }">
          <v-chip :color="item.color" dark>
            <v-icon small>mdi-file-document-outline</v-icon>
            <span> {{ item.old_filename }}</span>
          </v-chip>
        </template>
        <template v-slot:item.link_s3_png="{ item }">
          <v-tooltip top>
            <template v-slot:activator="{ on, attrs }">
              <img v-bind="attrs" v-on="on" :src="item.link_s3_png" style="width:20%;cursor: pointer;" @click="view_zoom(item)"/>
            </template>
            <span>zoom</span>
          </v-tooltip>
          <v-tooltip top>
            <template v-slot:activator="{ on, attrs }">
              <img v-bind="attrs" v-on="on" v-if="item.link_s3_plot" :src="item.link_s3_plot" style="width:20%;cursor: pointer;" @click="view_zoom(item)"/>
            </template>
            <span>zoom</span>
          </v-tooltip>
        </template>
      </v-data-table>
    </v-container>
    <!-- display -->
  </v-app>
</template>

<script>
export default {
  name: "Display",
  data() {
    return {
      api: process.env.VUE_APP_API,
      headers: [
        { text: "File Name", value: "old_filename", width: "15%" },
        { text: "Patient Name", value: "patient_name", width: "25%" },
        { text: "H/N", value: "HN", width: "15%" },
        { text: "Status", value: "status", sortable: false, width: "25%" },
        { text: "Result", value: "link_s3_png", sortable: false, width: "30%" }
      ],
      cols: 6,
      sm: 6,
      md: 6,
      dialog_feedback: false,
      form_feedback: {
        feed_back: "",
        upload_id: ""
      },
      scrollInvoked: 0,
      color: "",
      color_button: "",
      status: "",
      data_display: {},
      select_item: {},
      view_zoom_item: {},
      dialog_view_zoom: false,
      dialog_view_big_zoom: false,
      dialog_loader: false,
      pre_diagnosis_result: [],
      show_result: false,
      user_id: ""
    };
  },

  mounted() {
    console.log("api:", this.api)
    this.user_id = this.$cookies.get("info_login").user_id;
    // console.log("vuex-disease", this.$store.state.disease);
    const get_upload_id = this.$store.state.upload_id;
    const get_disease = this.$store.state.disease;
    console.log("check==>upload_id", get_upload_id);
    this.dialog_loader = true;
    this.data_display["upload_id"] = get_upload_id;
    this.data_display["disease"] = get_disease;
    this.data_display["user_id"] = this.$cookies.get("info_login").user_id;
    this.axios.post(process.env.VUE_APP_API + "/api/v3/process", this.data_display, {
        headers: {
          Authorization: this.$cookies.get("info_login").session_id
        }
      }).then(response => {
        console.log("response", response.data.data);
        console.log("response_all", response.data);
        if (response.data.status == "fail") {
          this.$swal({
            icon: "error",
            title: "Error!",
            text: response.data.message,
            confirmButtonText: "OK",
            allowOutsideClick: false
          }).then(() => {
            window.location.href = this.api;
          });
        }
      })
      .catch(error => {
        console.log("error", error);
        this.$router.push("/upload");
      });
  },
  methods: {
    returnCss(color) {
      return "color:" + color + ";";
    },
    onScroll() {
      this.scrollInvoked++;
    },

    view_item(item) {
      this.select_item = item;
      if (!item.status_fail) {
        this.color = "#B2DFDB";
        for (let index = 0; index < this.select_item.list_status_disease.length; index++) {
          this.status = this.select_item.list_status_disease[index];
        }
      } else {
        this.color = "red";
      }
      if (this.select_item.link_s3_plot == undefined) {
        this.cols = 6;
        this.sm = 6;
        this.md = 6;
      } else {
        this.cols = 12;
        this.sm = 6;
        this.md = 6;
      }
    },

    view_zoom(select_item) {
      this.form_feedback.feed_back = "";
      console.log("view-zoom", select_item);
      this.view_zoom_item = select_item;
      this.view_zoom_item["link_s3_png"] = select_item.link_s3_png;
      this.view_zoom_item["link_s3_plot"] = select_item.link_s3_plot;
      this.dialog_view_zoom = true;
    },

    view_big_zoom(select_item) {
      console.log(select_item);
      this.dialog_view_big_zoom = true;
    },

    feedback() {
      if (this.form_feedback.feed_back == null || this.form_feedback.feed_back == "")return;
      console.log("form_feedback", this.form_feedback);
      this.form_feedback["upload_id"] = this.view_zoom_item.upload_id;
      this.form_feedback["user_id"] = this.$cookies.get("info_login").user_id;
      this.view_zoom_item["feed_back"] = this.form_feedback.feed_back;
      console.log("check=>", this.view_zoom_item);
      this.axios
        .put(process.env.VUE_APP_API + "/api/v3/upload", this.form_feedback)
        .then(() => {
          this.$swal({
            icon: "success",
            title: "Success!",
            text: "Feedback success.",
            confirmButtonText: "OK",
            allowOutsideClick: false
          });
          // this.$refs.form_feedback.reset();
          // this.dialog_feedback = false;
        })
        .catch(error => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    close_dialog_feedback() {
      console.log("close");
      // this.$refs.form_feedback.reset();
      this.dialog_view_zoom = false;
    }
  },

  // sockets: {
  //   resultai: function(data) {
  //     console.log("result: ", data);
  //     console.log("user_id", this.user_id);
  //     console.log("data_user_id", data.user_id);
  //     if (this.user_id == data.user_id) {
  //       this.pre_diagnosis_result.push(data);
  //       // for-check-file-error
  //       for (let index = 0; index < this.pre_diagnosis_result.length; index++) {
  //         if (this.pre_diagnosis_result[index].status_fail) {
  //           this.pre_diagnosis_result[index]["color"] = "#F44336";
  //         } else {
  //           this.pre_diagnosis_result[index]["color"] = "#4CAF50";
  //         }
  //       }
  //       if (
  //         this.pre_diagnosis_result.length != 0 ||
  //         this.pre_diagnosis_result != undefined
  //       ) {
  //         if (
  //           this.pre_diagnosis_result.length ==
  //           this.data_display.upload_id.length
  //         ) {
  //           this.show_result = true;
  //           this.dialog_loader = false;
  //         }
  //       } else {
  //         return;
  //       }
  //     }
  //   }
  // },

  sockets: {
    resultai: function(data) {
      const foundUploadID = this.data_display["upload_id"].find(element => element == data.upload_id);
      console.log("foundUploadID:", foundUploadID);
      if (foundUploadID) {
        this.pre_diagnosis_result.push(data);
        // for-check-file-error
        for (let index = 0; index < this.pre_diagnosis_result.length; index++) {
          if (this.pre_diagnosis_result[index].status_fail) {
            this.pre_diagnosis_result[index]["color"] = "#F44336";
          } else {
            this.pre_diagnosis_result[index]["color"] = "#4CAF50";
          }
        }
        if (this.pre_diagnosis_result.length != 0 || this.pre_diagnosis_result != undefined) {
          if (this.pre_diagnosis_result.length == this.data_display.upload_id.length) {
            this.show_result = true;
            this.dialog_loader = false;
          }
        } else {
          return;
        }
      } else {
        console.log("upload_id ไม่ตรงใน data_display.uplad_id");
      }
    }
  }
};
</script>

<style scoped>
.eval {
  transition: 0.3s;
}
.eval:hover {
  box-shadow: 0 8px 16px 0 #26a69a;
  cursor: pointer;
}

.text-green input {
  color: green !important;
}

.tmp {
  /* border: black 1px solid; */
  width: 100px;
  margin: 5px;
  position: relative;
  word-wrap: break-word;
}

#wrap {
  word-wrap: break-word;
}
</style>
